﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="Abstract" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Abstract rule validations for Data Types that are applicable accross all of the AS services.</title>

<!-- GENERAL DATA TYPE ABSTRACT RULES 

    <xsd:simpleType name="NCName" id="NCName">
      <xsd:restriction base="xsd:Name">
        <xsd:pattern value="[\i-[:]][\c-[:]]*"/> (Relax NG pattern) 
      </xsd:restriction>
    </xsd:simpleType>
    -->

<rule abstract="true" id="xsd-datatype-ID">


<assert  id="CMN.ATO.GEN.001012" diagnostics="DCMN.ATO.GEN.001012" test="matches(.,'^[a-zA-Z_][a-zA-Z0-9_]*$')">ID supplied is invalid</assert>
</rule>

<rule abstract="true" id="xsd-datatype-date">


<assert  id="CMN.ATO.GEN.001008" diagnostics="DCMN.ATO.GEN.001008" test="@i:nil='true' or @i:nil='1' or (matches(.,'^(19|20)\d{2}-\d{2}-\d{2}$') and function:IsDate(.))">Field not supplied in valid date format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-monetary">


<assert  id="CMN.ATO.GEN.001009" diagnostics="DCMN.ATO.GEN.001009" test="@i:nil='true' or @i:nil='1' or matches(.,'^-?\d+$')">Field not supplied in valid monetary format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-boolean">


<assert  id="CMN.ATO.GEN.001010" diagnostics="DCMN.ATO.GEN.001010" test="@i:nil='true' or @i:nil='1' or matches(.,'^(0|1|true|false)$')">Field not supplied in valid boolean format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-positiveIntegerItemType">


<assert  id="CMN.ATO.GEN.001013" diagnostics="DCMN.ATO.GEN.001013" test="@i:nil='true' or @i:nil='1' or matches(.,'^[1-9]\d*$')">Field not supplied in valid Positive Integer format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-nonNegativeIntegerItemType">


<assert  id="CMN.ATO.GEN.001014" diagnostics="DCMN.ATO.GEN.001014" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d+$')">Field not supplied in valid Non Negative Integer format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-decimal">


<assert  id="CMN.ATO.GEN.001018" diagnostics="DCMN.ATO.GEN.001018" test="@i:nil='true' or @i:nil='1' or matches(.,'^[-]?\d+(\.\d+)?$')">Field not supplied in valid decimal format</assert>
</rule>
<!-- SBDH ABSTRACT RULES -->

<rule abstract="true" id="xsd-sbdh-datatype-date">


<assert  id="CMN.ATO.GEN.100012" diagnostics="DCMN.ATO.GEN.100012" test="@i:nil='true' or @i:nil='1' or (matches(.,'^(19|20)\d{2}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d+)?Z$') and function:IsDate(.))">SBDH: Field not supplied in valid xs:dateTime format</assert>
</rule>

<rule abstract="true" id="xsd-sbdh-datatype-integer">


<assert  id="CMN.ATO.GEN.100013" diagnostics="DCMN.ATO.GEN.100013" test="@i:nil='true' or @i:nil='1' or matches(.,'^[-]?\d+$')">SBDH: Field not supplied in valid xs:integer format</assert>
</rule>
<!-- SPECIFIC MONETARY TYPE RULES -->

<rule abstract="true" id="ato-datatype-monetary-u-10-0">


<assert  id="CMN.ATO.GEN.400011" diagnostics="DCMN.ATO.GEN.400011" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d{1,10}$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>

<rule abstract="true" id="ato-datatype-monetary-u-11-0">


<assert  id="CMN.ATO.GEN.400011" diagnostics="DCMN.ATO.GEN.400011" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d{1,11}$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>

<rule abstract="true" id="ato-datatype-monetary-u-13-2">


<assert  id="CMN.ATO.GEN.400011" diagnostics="DCMN.ATO.GEN.400011" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d{1,13}$|^\d{1,11}(\.\d{2})?$|^\d{1,12}(\.\d{1})?$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>

<rule abstract="true" id="ato-datatype-monetary-s-13-2">


<assert  id="CMN.ATO.GEN.400011" diagnostics="DCMN.ATO.GEN.400011" test="@i:nil='true' or @i:nil='1' or matches(.,'^[+-]?\d{1,13}$|^[+-]?\d{1,11}(\.\d{2})?$|^[+-]?\d{1,12}(\.\d{1})?$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>
<!-- SPECIFIC NUMBER TYPE RULES -->

<rule abstract="true" id="ato-datatype-number-u-6-0">


<assert  id="CMN.ATO.GEN.400012" diagnostics="DCMN.ATO.GEN.400012" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d{1,6}$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>

<rule abstract="true" id="ato-datatype-number-u-11-0">


<assert  id="CMN.ATO.GEN.400012" diagnostics="DCMN.ATO.GEN.400012" test="@i:nil='true' or @i:nil='1' or matches(.,'^\d{1,11}$')">Field incorrect format. Exceeds maximum digits or decimals and/or contains illegal characters</assert>
</rule>
<!-- SPECIFIC MAX LENGTH RULES -->

<rule abstract="true" id="maxLength-3">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,3}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-4">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,4}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-10">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,10}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-12">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,12}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-15">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,15}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-38">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,38}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-40">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,40}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-50">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,50}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-60">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,60}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-27">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,27}$')">Field value supplied exceeds maximum field length</assert>
</rule>

<rule abstract="true" id="maxLength-200">


<assert  id="CMN.ATO.GEN.001011" diagnostics="DCMN.ATO.GEN.001011" test="@i:nil='true' or @i:nil='1' or matches(.,'^.{0,200}$')">Field value supplied exceeds maximum field length</assert>
</rule>
<!-- SPECIFIC DATA TYPE ABSTRACT RULES 
 TODO: Remove these datatype validations until they are approved as some of these override existing business rules. -->

<rule abstract="true" id="xsd-datatype-sbrCountryNameCodeItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.) = 0 or matches(.,'^(af|ax|al|dz|as|ad|ao|ai|aq|ag|ar|am|aw|au|at|az|bs|bh|bd|bb|by|be|bz|bj|bm|bt|bo|ba|bw|bv|br|io|bn|bg|bf|bi|kh|cm|ca|cv|ky|cf|td|cl|cn|cx|cc|co|km|cg|cd|ck|cr|ci|hr|cu|cy|cz|dk|dj|dm|do|ec|eg|sv|gq|er|ee|et|fk|fo|fj|fi|fr|gf|pf|tf|ga|gm|ge|de|gh|gi|gr|gl|gd|gp|gu|gt|gg|gn|gw|gy|ht|hm|va|hn|hk|hu|is|in|id|ir|iq|ie|im|il|it|jm|jp|je|jo|kz|ke|ki|kp|kr|kw|kg|la|lv|lb|ls|lr|ly|li|lt|lu|mo|mk|mg|mw|my|mv|ml|mt|mh|mq|mr|mu|yt|mx|fm|md|mc|mn|me|ms|ma|mz|mm|na|nr|np|nl|an|nc|nz|ni|ne|ng|nu|nf|mp|no|om|pk|pw|ps|pa|pg|py|pe|ph|pn|pl|pt|pr|qa|re|ro|ru|rw|bl|sh|kn|lc|mf|pm|vc|ws|sm|st|sa|sn|rs|sc|sl|sg|sk|si|sb|so|za|gs|es|lk|sd|sr|sj|sz|se|ch|sy|tw|tj|tz|th|tl|tg|tk|to|tt|tn|tr|tm|tc|tv|ug|ua|ae|gb|us|um|uy|uz|vu|ve|vn|vg|vi|wf|eh|ye|zm|zw)$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrTelephoneNumberItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9a-zA-Z\s])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrFamilyNameItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9a-zA-Z \.,\?!\(\)\{\}:;''\|\-_=\\/@#$%\*=&amp;&quot;])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrGivenNameItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9a-zA-Z \.,\?!\(\)\{\}:;''\|\-_=\\/@#$%\*=&amp;&quot;])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrOrganisationNameItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9a-zA-Z \.,\?!\(\)\{\}:;''\|\-_=\\/@#$%\*=&amp;&quot;])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrOtherGivenNameItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9a-zA-Z \.,\?!\(\)\{\}:;''\|\-_=\\/@#$%\*=&amp;&quot;])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrPostcodeItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^[0-9]{4}$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrTaxAgentNumberItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^[0-9]{8}$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrTaxFileNumberItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^([0-9])*$')">Field not supplied in valid format</assert>
</rule>

<rule abstract="true" id="xsd-datatype-sbrTelephoneAreaCodeItemType">


<assert  id="CMN.ATO.GEN.001017" diagnostics="DCMN.ATO.GEN.001017" test="@i:nil='true' or @i:nil='1' or string-length(.)=0 or matches(.,'^[0-9]{2}$')">Field not supplied in valid format</assert>
</rule>
</pattern>