﻿<?xml version="1.0" encoding="utf-8"?>
<pattern id="Context" xmlns="http://purl.oclc.org/dsdl/schematron">
    <title>Validations for contexts that are applicable accross all of the FBT services.</title>

<!-- 
 DATA TYPE VALIDATIONS 
 -->

<rule name="VR.ATO.GEN.001002" context="xbrli:xbrl/xbrli:context/xbrli:period/xbrli:startDate">
<extends rule="xsd-datatype-date" />
</rule>

<rule name="VR.ATO.GEN.001002" context="xbrli:xbrl/xbrli:context/xbrli:period/xbrli:endDate">
<extends rule="xsd-datatype-date" />
</rule>
<!-- 
 CONTEXT VALIDATIONS 
 -->

<rule context="xbrli:xbrl">
<!--
        IF (INT:Identifier Scheme <> “http://www.ato.gov.au/abn”) OR (INT:entity.identifier.ABN = NULLORBLANK)
        RETURN VALIDATION MESSAGE
        ENDIF    
        -->


<assert  id="VR.ATO.GEN.000206" diagnostics="DVR.ATO.GEN.000206" subject="xbrli:context/xbrli:entity/xbrli:identifier" test="not(($Int.ContextId and 
                            (xbrli:context[@id=$Int.ContextId]/xbrli:entity/xbrli:identifier/@scheme != 'http://www.ato.gov.au/abn' or
                            count(xbrli:context[@id=$Int.ContextId]/xbrli:entity/xbrli:identifier[string-length(normalize-space(.)) != 0 and not(@i:nil='true' or @i:nil='1')]) = 0)))">Tax file number is required</assert>
<!--
            IF (RP:entity.identifier.ABN = NULLORBLANK) AND (CONTEXT (INT = NULLORBLANK))
            RETURN VALIDATION MESSAGE
            ENDIF
        -->


<assert  id="VR.ATO.GEN.000207" diagnostics="DVR.ATO.GEN.000207" subject="xbrli:context/xbrli:entity/xbrli:identifier" test="not(count(xbrli:context[@id=$Int.ContextId])=0 and
                          (count(xbrli:context[@id=$RP.ContextId]/xbrli:entity/xbrli:identifier[@scheme='http://www.ato.gov.au/abn' and not(@i:nil='true' or @i:nil='1')]) = 0
                          or string-length(xbrli:context[@id=$RP.ContextId]/xbrli:entity/xbrli:identifier[@scheme='http://www.ato.gov.au/abn' and not(@i:nil='true' or @i:nil='1')]) = 0
                          or xbrli:context[@id=$RP.ContextId]/xbrli:entity/xbrli:identifier[@scheme='http://www.ato.gov.au/abn' and (@i:nil='true' or @i:nil='1')]))">ABN is required unless an Intermediary is provided</assert>
<!--
            IF COUNT(RP) <> 1
            RETURN VALIDATION MESSAGE
            ENDIF
        -->


<assert  id="VR.ATO.GEN.000208" diagnostics="DVR.ATO.GEN.000208" subject="xbrli:context" test="count(xbrli:context[@id=$RP.ContextId]) = 1">Invalid XBRL schema</assert>
<!--
            IF COUNT(INT) > 1
            RETURN VALIDATION MESSAGE
            ENDIF
        -->


<assert  id="VR.ATO.GEN.000226" diagnostics="DVR.ATO.GEN.000226" subject="xbrli:context" test="count(xbrli:context[@id=$Int.ContextId]) &lt;= 1">Invalid XBRL schema</assert>
<!--
            IF (Identifier Scheme <> “http://www.ato.gov.au/abn”) AND (Identifier Scheme <> “http://www.ato.gov.au/tfn”)
            RETURN VALIDATION MESSAGE
            ENDIF     
        -->


<assert  id="VR.ATO.GEN.000239" diagnostics="DVR.ATO.GEN.000239" subject="xbrli:context/xbrli:entity/xbrli:identifier" test="count(xbrli:context/xbrli:entity/xbrli:identifier[not(@scheme='http://www.ato.gov.au/abn') and not(@scheme='http://www.ato.gov.au/tfn')]) = 0">Invalid XBRL schema</assert>
<!--
            Explicit member dimension ReportPartyType set to ReportingParty or Intermediary
            IF (RprtPyType.02.03:ReportPartyTypeDimension <> "h04. 02.00:Intermediary") AND (h04. 02.00:ReportPartyTypeDimension <> "h04. 02.00:ReportingParty")
            RETURN VALIDATION MESSAGE
            ENDIF
        -->


<assert  id="VR.ATO.GEN.000248" diagnostics="DVR.ATO.GEN.000248" subject="xbrli:context/xbrli:entity/xbrli:segment/xbrldi:explicitMember" test="count(xbrli:context/xbrli:entity/xbrli:segment/xbrldi:explicitMember[not(contains(.,'Intermediary')) and not(contains(.,'ReportingParty'))]) = 0">Invalid XBRL schema</assert>
</rule>

<rule context="xbrli:xbrl[not(@i:nil='true' or @i:nil='1')]/xbrli:context[not(@i:nil='true' or @i:nil='1')]/xbrli:entity[not(@i:nil='true' or @i:nil='1')]/xbrli:identifier[not(@i:nil='true' or @i:nil='1')]">

<!-- 
            IF entity.identifier.ABN <> NULLORBLANK AND ABNALGORITHM(entity.identifier.ABN) = FALSE)
                RETURN VALIDATION MESSAGE
            ENDIF
        -->

<assert  id="VR.ATO.GEN.430318" diagnostics="DVR.ATO.GEN.430318" test="not(upper-case(@scheme) = 'HTTP://WWW.ATO.GOV.AU/ABN') 
                  or string-length(normalize-space(.)) = 0 
                  or function:ValidateABN(.)"></assert>

</rule>

</pattern>